using System.Collections.Generic;
using System.Text;
using System.Web.Mvc;
using MvcGallery3.Extensions.Html.Grid;

namespace MvcGallery3.Extensions.Html
{
    public static class SimpleGridHelper
    {
        // Very simple GENERIC grid generator
        public static MvcHtmlString SimpleGrid<T>(this HtmlHelper helper, 
            ICollection<T> dataSource, 
            IList<IDataTransformer> transformers = null)
        {
            // Grab type information (only public properties)
            var columns = GridColumnDescriptor.ExtractPropertiesFrom<T>();
            
            // Build the HTML table
            var builder = new StringBuilder();
            builder.Append("<table><thead>");
            foreach(var c in columns)
            {
                builder.AppendFormat("<th>{0}</th>", c.HeaderText);
            }
            builder.Append("</thead>");

            foreach (var item in dataSource)
            {
                builder.Append("<tr>");
                foreach (var c in columns)
                {
                    var propertyValue = GridColumnDescriptor.GetValueFor(c.BoundProperty, item, c);
                    builder.AppendFormat("<td>{0}</td>", propertyValue);
                }
                builder.Append("</tr>");
            }

            builder.Append("</table>");
            return MvcHtmlString.Create(builder.ToString());
        }
    }
}