using System;
using System.Collections.Generic;
using System.Linq;

namespace MvcGallery3.Extensions.Html
{
    public class PagedViewModel<T>
    {
        private ICollection<T> _dataSource = null;

        public Int32 PageSize { get; set; }
        public Int32 PageIndex { get; set; }
        public Int32 ItemCount { get; private set; }
        public ICollection<T> DataSource
        {
            get
            {
                if (_dataSource == null)
                    return new List<T>();
                return (from d in _dataSource select d).Skip(PageSize*(PageIndex - 1)).Take(PageSize).ToList();
            }
            set
            {
                _dataSource = value;
                ItemCount = _dataSource.Count;
            }
        }
    }
}