﻿using System;
using System.Collections.Generic;
using System.Web.Mvc;
using System.Web.Routing;

namespace MvcGallery3.Extensions.Html
{
    public static class SubmitButtonHelper
    {
        public static MvcHtmlString Submit(this HtmlHelper helper, String name)
        {
            return Submit(helper, name, name, null);
        }

        public static MvcHtmlString Submit(this HtmlHelper helper, String name, String caption)
        {
            var buttonText = (caption ?? name);
            return Submit(helper, name, buttonText, null);
        }

        public static MvcHtmlString Submit(this HtmlHelper helper, String name, String caption, Object htmlAttributes)
        {
            var buttonText = (caption ?? name);

            // Convert from object to dictionary
            var dict = (IDictionary<String, Object>) new RouteValueDictionary(htmlAttributes);

            // Build the button (TagBuilder requires System.Web.WebPages)
            var submit = new TagBuilder("input");
            submit.MergeAttributes(dict);
            submit.MergeAttribute("type", "submit");
            submit.MergeAttribute("value", buttonText);
            submit.MergeAttribute("name", name, true);

            return MvcHtmlString.Create(submit.ToString(TagRenderMode.SelfClosing));
        }
    }
}