using System;
using System.Collections.Generic;
using System.Web.Mvc;

namespace MvcGallery3.Extensions.Providers
{
    public class ExtendedAnnotationsMetadataProvider : DataAnnotationsModelMetadataProvider
    {
        protected override ModelMetadata CreateMetadata(IEnumerable<Attribute> attributes, 
            Type containerType,
            Func<Object> modelAccessor,
            Type modelType,
            String propertyName)
        {
            var metadata = base.CreateMetadata(
                attributes,
                containerType,
                modelAccessor,
                modelType,
                propertyName);

            if (metadata.IsReadOnly)
                metadata.TemplateHint = "readonly";
            return metadata;
        }
    }
}