using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;

namespace MvcGallery3.Extensions.Providers
{
    public class SampleDependencyResolver : IDependencyResolver
    {
        public object GetService(Type serviceType)
        {
            try
            {
                return serviceType == typeof(ModelMetadataProvider) 
                    ? new ExtendedAnnotationsMetadataProvider() 
                    : Activator.CreateInstance(serviceType);
            }
            catch
            {
                return null;
            }
        }

        public IEnumerable<object> GetServices(Type serviceType)
        {
            return Enumerable.Empty<object>();
        }
    }
}