using System;
using System.Collections.Generic;
using System.Web.Mvc;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;

namespace MvcGallery3.Extensions.Providers
{
    public class UnityDependencyResolver : IDependencyResolver
    {
        private readonly IUnityContainer _container;

        public UnityDependencyResolver() : this(new UnityContainer().LoadConfiguration())
        {
        }
        public UnityDependencyResolver(IUnityContainer container)
        {
            _container = container;
        }

        public Object GetService(Type serviceType)
        {
            return _container.Resolve(serviceType);
        }

        public IEnumerable<Object> GetServices(Type serviceType)
        {
            return _container.ResolveAll(serviceType);
        }
    }
}