using System.Web.Mvc;

namespace MvcGallery3.Extensions.ViewEngines
{
    public class PartialRazorViewEngine : RazorViewEngine 
    {
        public PartialRazorViewEngine()
        {
            // Difference: It looks for cshtml/vbhtml files only in PartialViews folder
            PartialViewLocationFormats = new[]
                                             {
                                                 "~/PartialViews/{1}/{0}.cshtml",
                                                 "~/PartialViews/{1}/{0}.vbhtml",
                                                 "~/PartialViews/Shared/{0}.cshtml",
                                                 "~/PartialViews/Shared/{0}.vbhtml"
                                                 //"~/Views/{1}/{0}.cshtml",
                                                 //"~/Views/{1}/{0}.vbhtml",
                                                 //"~/Views/Shared/{0}.cshtml",
                                                 //"~/Views/Shared/{0}.vbhtml"
                                             };
            AreaPartialViewLocationFormats = new []
                                                 {
                                                     "~/Areas/{2}/PartialViews/{1}/{0}.cshtml", 
                                                     "~/Areas/{2}/PartialViews/{1}/{0}.vbhtml", 
                                                     "~/Areas/{2}/PartialViews/Shared/{0}.cshtml", 
                                                     "~/Areas/{2}/PartialViews/Shared/{0}.vbhtml"
                                                 };
        }
    }
}