using System;
using System.Collections.Generic;
using System.Linq;
using Northwind.DAL.Repositories.Abstractions;
using Northwind.Model;

namespace Northwind.DAL.Repositories
{
    public class CustomerRepository : ICustomerRepository
    {
        public Customer FindById(String id)
        {
            using(var context = new NorthwindEntities())
            {
                var customer = (from c in context.Customers
                                where c.CustomerID == id
                                select c).FirstOrDefault();
                return customer;
            }
        }

        public IList<Customer> FindAll()
        {
            using (var context = new NorthwindEntities())
            {
                var customers = (from c in context.Customers
                                 select c).ToList();
                return customers;
            }            
        }

        public Boolean Update(Customer customer)
        {
            return true;
        }
    }
}