﻿using System.Collections.Generic;
using System.ServiceModel.Syndication;
using System.Web.Mvc;
using AsyncApp.Common;

namespace AsyncApp.Controllers
{
    public class NewsController : AsyncController
    {
        private readonly INewsHumbleObject _humbleObject;
        public NewsController() : this(new NewsHumbleObject())
        {
        }
        public NewsController(INewsHumbleObject humbleObject)
        {
            _humbleObject = humbleObject;
        }


        public void TennisAsync()
        {
            var url = "http://feeds2.feedburner.com/Tennis-AtpWorldTourHeadlineNews";
            _humbleObject.Prepare(AsyncManager);
            _humbleObject.GetFeedItems(url, AsyncManager);
        }

        public ActionResult TennisCompleted(IList<SyndicationItem> feedItems)
        {
            return View(feedItems);
        }
    }
}
