﻿using System;
using System.Web.Mvc;

namespace HelloMvc.Controllers
{
    public class HomeController : Controller
    {
        [ActionName("Index")]
        public ActionResult Index1()
        {
            // 1. Validate and process input data

            // 2. Invoke some functions on the middle tier and get values

            // 3. Prepare data for the view 

            // 4. Trigger the view engine
            return View();
        }

        public ActionResult About()
        {
            ViewData["Param1"] = "DinoEsp";
            ViewBag.Param1 = "DinoEsp";

            return View();
        }

        public ActionResult Echo()
        {
            // Request.Params includes: query string, form, cookies, server vars. Same if you use the Request.Item indexer property.
            // You can also use the ValueProvider.GetValue expression to retrieve input data from 
            // more value providers: child actions params, form, routes, query string, file collection
            //var data = ValueProvider.GetValue("data").AttemptedValue ??
            //           (ValueProvider.GetValue("todaY").AttemptedValue ?? String.Empty);

            // Capture data in some manual way (case-insensitive search)
            var data = RouteData.Values["data"] ?? (Request.Params["today"] ?? String.Empty);

            // Pass data to display in the view
            ViewBag.Data = data;

            // Invoke the view
            return View();
        }

        public ActionResult ShowNumber()
        {
            ViewBag.Id = RouteData.Values["id"] ?? -1;
            return View();
        }

        [NonAction]
        public ActionResult Foo()
        {
            return View();
        }
    }
}
