﻿
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using MvcGallery3.Extensions.Constraints;

namespace HelloMvc
{
    public class MvcApplication : HttpApplication
    {
        protected void Application_Start()
        {
            RegisterRoutes(RouteTable.Routes);
        }

        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            // Skip over requests for AXD resources
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            #region Additional routes (custom handler & constraints)

            // Determine controller/action via defaults
            routes.MapRoute(
                "AboutRoute",
                "about",
                new { controller = "Home", action = "About" }
            );

            // Partly constant route URL
            routes.MapRoute(
                "EchoRoute",
                "echo/{data}",
                new { controller = "Home", action = "Echo", data = UrlParameter.Optional }
            );

            // Apply constraints to the parameter
            routes.MapRoute(
                "NumericRoute",
                "Num/{id}",
                new { controller = "Home", action = "ShowNumber", id = UrlParameter.Optional },
                new { id = @"\d{3}" }
            );

            routes.MapRoute(
                "NumericRouteEven",
                "Even/{id}",
                new { controller = "Home", action = "ShowNumber", id = UrlParameter.Optional },
                new { id = new EvenConstraint() }
            );
            #endregion

            // Add standard route of ASP.NET MVC applications
            routes.MapRoute(
                "Default",  
                "{controller}/{action}/{id}",  
                new { controller = "Home", action = "Index", id = UrlParameter.Optional }  
            );
        }

    }
}