﻿using System;
using System.Linq;
using System.Web.Mvc;
using MultiArea.Areas.Store.Models;
using Northwind.DAL;

namespace MultiArea.Areas.Store.Controllers
{
    public class CustomerController : Controller
    {
        // Return the main page for navigating within the list of customers
        public ActionResult Search()
        {
            // No task to accomplish; just render the view
            return View();
        }

        // Return the list of customers for a given initial
        public ActionResult List(String initial)
        {
            // Perform the task
            var context = new NorthwindEntities();
            var data = (from c in context.Customers
                        where c.CompanyName.StartsWith(initial) 
                        select c).ToList();

            // Prepare the view model, then render the view
            var model = new CustomerListViewModel {Customers = data, Match = initial};
            return View(model);
        }

        public ActionResult Details(String id)
        {
            // Perform the task
            var context = new NorthwindEntities();
            var data = (from c in context.Customers
                        where c.CustomerID == id
                        select c).FirstOrDefault();

            // Prepare the view model, then render the view
            var model = new CustomerDetailsViewModel { Customer = data, OrderCount = data.Orders.Count() };
            return View(model);
        }
    }
}
