﻿using System.Web.Mvc;
using System.Web.Routing;
using RouteHandler.Components;


namespace RouteHandler
{
    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            // Add a route based on a custom handler (specify controller/action as optional)
            var optionals = new RouteValueDictionary
                                {{"controller", UrlParameter.Optional}, {"action", UrlParameter.Optional}};

            // Nicely enough, if you set optionals to null then you break the markup returned by ActionLink. 
            // You should be using RouteLink to keep things working as expected.
            routes.Add("AboutRoute", new Route("aboutme", optionals, new AboutRouteHandler()));

            // Default route
            routes.MapRoute(
                "Default", 
                "{controller}/{action}/{id}",  
                new { controller = "Home", action = "Index", id = UrlParameter.Optional } 
            );

        }

        protected void Application_Start()
        {
            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
        }
    }
}