﻿using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Web.Mvc;
using ViewModelDemo.ViewModels.Order;

namespace ViewModelDemo.Controllers
{
    public class OrderController : Controller
    {
        public ActionResult Latest()
        {
            // 1. Make a query and get the latest order

            // 2. Pass data to the view
            var model = new LatestOrderViewModel
                            {
                                OrderDate = DateTime.Today,
                                Status = "Pending"
                            };
            return View(model);
        }

        public ActionResult Pending()
        {
            // 1. Make a query and get the pending orders

            // 2. Pass data to the view
            var model = new PendingOrdersViewModel 
                            {
                                Orders = new List<dynamic>()
                            };
            dynamic o1 = new ExpandoObject();
            o1.OrderDate = DateTime.Today;
            o1.Status = "Pending";
            model.Orders.Add(o1);
            dynamic o2 = new ExpandoObject();
            o2.OrderDate = DateTime.Today.AddDays(-1);
            o2.Status = "Pending";
            model.Orders.Add(o2);
            dynamic o3 = new ExpandoObject();
            o3.OrderDate = DateTime.Today.AddDays(-1);
            o3.Status = "Pending";
            model.Orders.Add(o3);

            return View(model);
        }
    }
}
