﻿using System;
using System.Collections.Generic;
using System.Web.Mvc;
using RenderAction.ViewModels;

namespace RenderAction.Controllers
{
    public class MenuController : Controller
    {
        [ChildActionOnly]
        public ActionResult List()
        {
            var model = new MenuViewModel();
            model.MenuItems.Add(new MenuItem() { ActionName = "index", ControllerName = "Home", LinkText = "Home" });
            model.MenuItems.Add(new MenuItem() { ActionName = "about", ControllerName = "Home", LinkText = "About us" });
            return PartialView("_Menu", model);
        }

        [ChildActionOnly]
        public ActionResult List1(IList<MenuItem> items)
        {
            var model = new MenuViewModel();
            foreach (var menuItem in items)
            {
                model.MenuItems.Add(menuItem);
            }
            return PartialView("_Menu", model);
        }

        [ChildActionOnly]
        [OutputCache(Duration=5)]
        public ActionResult CurrentTime()
        {
            return PartialView("_CurrentTime");
        }

        [ChildActionOnly]
        [OutputCache(Duration = 5)]
        public ActionResult Copyright()
        {
            return Content("Courtesy of 'Programming ASP.NET MVC'", "text/html");
        }
    }
}
