﻿using System;
using System.Web.Mvc;
using BasicInput.ViewModels.Date;
using MvcGallery3.Extensions.Binders;

namespace BasicInput.Controllers
{
    public class DateController : Controller
    {
        [HttpGet]
        [ActionName("Editor")]
        public ActionResult EditorForGet()
        {
            var model = new DateEditorViewModel();
            return View(model);
        }

        [HttpPost]
        [ActionName("Editor")]
        public ActionResult EditorForPost(
            [ModelBinder(typeof(DateModelBinder))]DateTime theDate)
        {
            // Local model-binder takes precedence over other matching binders 
            // defined in global.asax.
            var model = new DateEditorViewModel();
            if (theDate != default(DateTime))
            {
                model.DefaultDate = theDate;
                model.TimeToToday = DateTime.Today.Subtract(theDate);
            }
            return View(model);
        }
    }
}
