﻿using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using MvcGallery3.Extensions.Providers;

namespace DataAnnotations
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : HttpApplication
    {
        /// <summary>
        /// Register application-specific global filters.
        /// </summary>
        /// <param name="filters">Built-in filter collection to extend</param>
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        /// <summary>
        /// Register application-specific routes.
        /// </summary>
        /// <param name="routes">Built-in route collection to extend</param>
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
            );

        }

        /// <summary>
        /// Handler for the application startup point.
        /// </summary>
        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();
            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);

            // Custom metadata provider to recognize and handle ReadOnly attribute 
            // (only one type of registration for ModelMetadataProvider)
            ModelMetadataProviders.Current = new ExtendedAnnotationsMetadataProvider();
            //DependencyResolver.SetResolver(new SampleDependencyResolver());
        }
    }
}