﻿using System;
using System.Web.Mvc;
using Northwind.Model;
using SEP.WorkerServices.Abstractions;
using SEP.WorkerServices.Customers;


namespace SEP.Controllers
{
    public class CustomerController : Controller
    {
        private readonly ICustomerWorkerServices _service;

        public CustomerController() : this(new CustomerWorkerServices())
        {
        }
        public CustomerController(ICustomerWorkerServices service)
        {
            _service = service;
        }

        public ActionResult Edit([Bind(Prefix = "customerList")] String customerId)
        {
            var model = _service.EditCustomer(customerId);
            return View(model);
        }

        public ActionResult Update(Customer customer)
        {
            var model = _service.TryUpdateCustomer(ControllerContext, customer);
            return View("Edit", model);
        }
    }
}
