﻿using System;
using System.Web.Mvc;
using MultiLang.Resources.Text;
using MultiLang.ViewModels.Home;
using MvcGallery3.Extensions.Filters;

namespace MultiLang.Controllers
{
    public class HomeController : Controller
    {
        /// <summary>
        /// Display the home page
        /// </summary>
        /// <returns>HTML</returns>
        public ActionResult Index()
        {
            var model = new HomeIndexViewModel
                            {
                                Title = Strings.HomeIndexTitle,
                                Message = String.Format(Strings.WelcomeMessageFormat, Strings.AppName)
                            };
            return View(model);
        }

        /// <summary>
        /// Display the About page
        /// </summary>
        /// <returns>HTML</returns>
        public ActionResult About()
        {
            var model = new AboutUsViewModel
                            {
                                Title = Strings.HomeAboutTitle,
                                ContactInfo = Strings.Contact
                            };
            return View(model);
        }
    }
}
