using System;
using System.Web;
using System.Web.Security;
using DotNetOpenAuth.OAuth.Messages;

namespace TwitterAuth.Framework
{
    public static class DnoaExtensions
    {
        public static HttpCookie CreateAuthCookie(this AuthorizedTokenResponse accessTokenResponse, Boolean persistent = true)
        {
            var accessToken = accessTokenResponse.AccessToken;
            var username = accessTokenResponse.ExtraData["screen_name"];
            return CreateAuthCookie(username, accessToken, persistent);
        }

        private static HttpCookie CreateAuthCookie(String username, String token, Boolean persistent)
        {
            // Let ASP.NET create a regular auth cookie  
            var cookie = FormsAuthentication.GetAuthCookie(username, persistent);

            // Modify the cookie to add access-token data 
            var ticket = FormsAuthentication.Decrypt(cookie.Value);
            var newTicket = new FormsAuthenticationTicket(ticket.Version, ticket.Name, ticket.IssueDate, ticket.Expiration, ticket.IsPersistent, token);
            cookie.Value = FormsAuthentication.Encrypt(newTicket);

            return cookie;
        }
    }
}