﻿using System;
using System.Web.Mvc;
using MvcGallery3.Extensions.Security;

namespace StandardAuth.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "This application doesn't really allow you to do much without logging in!";
            return View();
        }

        [AuthorizedOnly(Users="dino")]
        public ActionResult About()
        {
            return View();
        }

        [AuthorizedOnly]
        public ActionResult Now()
        {
            ViewBag.Now = DateTime.Now.ToString("hh:mm:ss");
            if (Request.IsAjaxRequest())
                return PartialView("aNow");

            return View();
        }
    }
}
