﻿using System.Web.Mvc;
using FatFree.Resources;
using FatFree.ViewModels.Home;
using FatFree.WorkerServices.Abstractions;
using FatFree.WorkerServices.Home;

namespace FatFree.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHomeServices _workerService;

        public HomeController() : this(new HomeServices())
        {
            
        }
        public HomeController(IHomeServices service)
        {
            _workerService = service;
        }

        /// <summary>
        /// Display the home page
        /// </summary>
        /// <returns>HTML</returns>
        public ActionResult Index()
        {
            var model = _workerService.GetHomeViewModel();
            return View(model);
        }

        /// <summary>
        /// Display the About page
        /// </summary>
        /// <returns>HTML</returns>
        public ActionResult About()
        {
            var model = new AboutUsViewModel
                            {
                                Title = Strings.HomeAboutTitle,
                                ContactInfo = Strings.Contact
                            };
            return View(model);
        }
    }
}
