﻿using System;
using System.Collections.Generic;
using System.ServiceModel.Syndication;
using AsyncApp.Controllers;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Moq;
using SampleApp.Tests.Helpers;

// See Ch01.AsyncApp example for classes being tested.

namespace SampleApp.Tests.Async
{
    [TestClass]
    public class AsyncTests
    {
        [TestMethod]
        public void Test_If_News_Are_Being_Downloaded_Async()
        {
            // Arrange
            var humbleObject = new FakeNewsHumbleObject();
            var controller = new NewsController(humbleObject);
            controller.TennisAsync();

            // Act
            var response = controller.AsyncManager.Parameters["feedItems"]
                        as IList<SyndicationItem>;

            // Assert
            Assert.IsNotNull(response);
            Assert.AreEqual(response.Count, 3);
        }
    }
}
