﻿using System;
using System.Web.Mvc;
using AgenderWeb.WorkerServices;

namespace AgenderWeb.Controllers
{
    public class ScheduleController : Controller
    {
        private readonly IScheduleServices _service;

        public ScheduleController() : this(new ScheduleServices())
        {
        }
        public ScheduleController(IScheduleServices service)
        {
            _service = service;
        }

        public ActionResult Index()
        {
            var model = _service.GetContentForMainMenu();
            return View(model);
        }

        public ActionResult Days()
        {
            var model = _service.GetContentForMainMenu();
            return PartialView("index", model);
        }

        public ActionResult Day([Bind(Prefix="id")]Int32 dayIndex)
        {
            var model = _service.GetContentForDay(dayIndex);
            return PartialView(model);
        }

        [ActionName("session")]
        public ActionResult GetSession(String id, Int32 returnIndex)
        {
            var model = _service.GetSessionDetails(id, returnIndex);
            return PartialView(model);
        }

        public ActionResult Speakers()
        {
            var model = _service.GetSpeakers();
            return PartialView(model);
        }

        public ActionResult Speaker(String id)
        {
            var model = _service.GetSpeakerAndSessions(id);
            return PartialView(model);
        }
    }
}
