﻿using System;
using System.Web.Mvc;
using eTennisConf.WorkerServices;
using MvcGallery3.Extensions.Filters;

namespace eTennisConf.Controllers
{
    public class AjaxController : Controller
    {
        private readonly IScheduleServices _service;

        public AjaxController() : this(new ScheduleServices())
        {
        }
        public AjaxController(IScheduleServices service)
        {
            _service = service;
        }
        
        [AjaxOnly]
        public ActionResult Day([Bind(Prefix="id")]Int32 dayIndex)
        {
            var model = _service.GetContentForDay(dayIndex);
            return Json(model, JsonRequestBehavior.AllowGet);
        }

        [AjaxOnly]
        [ActionName("session")]
        public ActionResult GetSession(String id)  
        {
            var model = _service.GetSessionDetails(id); 
            return Json(model, JsonRequestBehavior.AllowGet);
        }

        [AjaxOnly]
        public ActionResult Speakers()
        {
            var model = _service.GetSpeakers();
            return Json(model, JsonRequestBehavior.AllowGet);
        }

        [AjaxOnly]
        public ActionResult Speaker(String id)
        {
            var model = _service.GetSpeakerAndSessions(id);
            return Json(model, JsonRequestBehavior.AllowGet);
        }
    }
}
