﻿using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using AgenderCore.Framework;

namespace eTennisConf
{
    public class MvcApplication : HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default",  
                "{controller}/{action}/{id}",  
                new { controller = "Home", action = "Index", id = UrlParameter.Optional }  
            );

        }

        public static ConferenceInfo GetData()
        {
            var schedule = HttpContext.Current.Cache["ConferenceData"] as ConferenceInfo;
            if (schedule == null)
            {
                var contentFile = HttpContext.Current.Server.MapPath("~/App_Data/TennisConference.xml");
                schedule = ContentReader.Load(contentFile);
                HttpContext.Current.Cache["ConferenceData"] = schedule;
            }
            return schedule;
        }

        protected void Application_Start()
        {
            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
        }
    }
}