using System;
using eTennisConf.ViewModels;

namespace eTennisConf.WorkerServices
{
    public class ScheduleServices : IScheduleServices
    {
        public MainMenuViewModel GetContentForMainMenu()
        {
            var schedule = MvcApplication.GetData();
            var model = new MainMenuViewModel
                            {
                                Date = schedule.Date,
                                Location = schedule.Location,
                                ViewTitle = schedule.Conference,
                                Days = schedule.Days
                            };
            return model;
        }

        public DayViewModel GetContentForDay(Int32 index)
        {
            var schedule = MvcApplication.GetData();
            var model = new DayViewModel {CurrentDay = schedule.Days[index]};
            model.ViewTitle = model.CurrentDay.Date;
            model.DayIndex = index;
            return model;
        }

        public SessionViewModel GetSessionDetails(String id) 
        {
            var schedule = MvcApplication.GetData();
            var model = new SessionViewModel { CurrentSession = schedule.GetSessionById(id) };
            model.ViewTitle = "Session: " + id;
            return model;
        }
        
        public SpeakersViewModel GetSpeakers()
        {
            var schedule = MvcApplication.GetData();
            var model = new SpeakersViewModel();
            model.ViewTitle = "Speakers";
            model.Speakers = schedule.Speakers;
            return model;
        }
        
        public SpeakerViewModel GetSpeakerAndSessions(String id)
        {
            var schedule = MvcApplication.GetData();
            var model = new SpeakerViewModel();
            model.Speaker = schedule.GetSpeakerById(id);
            model.Sessions = schedule.GetSessionsForSpeaker(id);
            model.ViewTitle = model.Speaker.Name;
            return model;
        }
    }
}